'use strict';

/* App Module */

var duarteApp = angular.module('duarteApp', [
  'ngRoute',
  'ngAnimate',
  'services',
  'ngSanitize',
  'ngTouch',
  'uiGmapgoogle-maps'
]);

duarteApp.run(function($rootScope, $location, $window) {
    
    $rootScope.$on('$routeChangeSuccess', function () {
        $window.scrollTo(0, 0);
    });

    $rootScope.getNotification = function(data){
        if(parseInt(data.type) === 1){
            $rootScope.$apply(function(){ $location.path('/events/'+data.alias_id+'/00/00');});
        }else if(parseInt(data.type) === 0){
            $rootScope.$apply(function(){$location.path('/news/'+data.alias_id);});
        }
    }
});

/* Routes */
duarteApp.config(['$routeProvider',
  function($routeProvider) {
    $routeProvider.
      when('/', {
        templateUrl: 'partials/main.html'
      }).
      when('/categories', {
        templateUrl: 'partials/categories.html',
        controller: 'listCtrl'
      }).
      when('/category/:catName', {
        templateUrl: 'partials/category.html',
        controller: 'catCtrl'
      }).
      when('/events', {
        templateUrl: 'partials/event-list.html',
        controller: 'listCtrl'
      }).
      when('/events/:eventId/:curEvent/:totEvents', {
        templateUrl: 'partials/event-detail.html',
        controller: 'detailCtrl'
      }).
      when('/trivia', {
        templateUrl: 'partials/trivia.html',
        controller: 'triviaCtrl'
      }).
      when('/frases', {
        templateUrl: 'partials/frases.html',
        controller: 'frasesCtrl',
      }).
      when('/favorites', {
        templateUrl: 'partials/favorites.html',
        controller: 'favoritesCtrl'
      }).
      when('/news', {
        templateUrl: 'partials/news.html',
        controller: 'newsCtrl'
      }).
      when('/news/:nwId', {
        templateUrl: 'partials/news-detail.html',
        controller: 'newsCtrl'
      }).
      otherwise({
        redirectTo: '/'
      });
  }]);