'use strict';

/* Controllers */

// App Globals
duarteApp.controller('mainCtrl', function($scope, $rootScope, $location, $sce) {

	// Page Transitions
	var styles = {

	front: '.page.interior.ng-enter { bottom: 0; -webkit-transition: 0.5s ease; -webkit-transform:translateX(100%) }  .page.interior.ng-enter-active { bottom: 0; -webkit-transform:translate(0,0)}  .page.interior.ng-leave { bottom: 0; -webkit-transition: 0.5s ease; -webkit-transform:translateX(0)} .page.interior.ng-leave-active { bottom: 0; -webkit-transform:translate(-100%,0) };',

	back: '.page.interior.ng-enter { bottom: 0; -webkit-transition: 0.5s ease; -webkit-transform:translateX(-100%) }  .page.interior.ng-enter-active { bottom: 0; -webkit-transform:translate(0,0)}  .page.interior.ng-leave { bottom: 0; -webkit-transition: 0.5s ease; -webkit-transform:translateX(0)} .page.interior.ng-leave-active { bottom: 0; -webkit-transform:translate(100%,0) };'

	};

	$scope.direction = function(dir) {
		$rootScope.style = $sce.trustAsHtml(styles[dir]);
	}

	$scope.direction('front');

});


// Events Categories
duarteApp.controller('catCtrl', ['$scope', '$routeParams', 'Cats',
function($scope, $routeParams, Cats) {
	$scope.cats = Cats.query();
	$scope.catName = $routeParams.catName;
}]);


// Events Page
duarteApp.controller('listCtrl', ['$scope', 'Event',
function($scope, Event) {
	$scope.events = Event.query();
	$scope.hideKey = function () {
		var devicePlatform = device.platform;
		if (devicePlatform == 'Android') {
			SoftKeyboard.hide();
		}
	}
}]);


// Event Page Nav
duarteApp.controller('listCtrlNav', ['$scope', 'Event',
function($scope, Event) {
	$scope.events = Event.query();
}]);


// Event Detail Page
duarteApp.controller('detailCtrl', ['$scope', '$routeParams', 'Event',
function($scope, $routeParams, Event) {

	Event.get({eventId: $routeParams.eventId}).$promise.then(function(e){
		$scope.event = e;

		if($routeParams.curEvent == '00' && $routeParams.totEvents == '00'){
			$scope.displayNav = false;
		}else{
			$scope.displayNav = true;
			$scope.curEvent = $routeParams.curEvent;
			$scope.totEvents = $routeParams.totEvents;
		}

		// Favorites Button
		if (localStorage.getItem($routeParams.eventId) != null) {
			var favBtn = document.getElementById('fav');
			favBtn.innerHTML = '<i class="fa fa-bookmark"></i>';
		}

		$scope.map = {
			center: {
				latitude: $scope.event.mapa[0], longitude: $scope.event.mapa[1]
			},
			zoom: 16
		};
		$scope.options = {
			draggable: false,
            scrollwheel: false,
            mapTypeControl: false,
            panControl: false,
            scaleControl: false,
            zoomControl: true,
            zoomControlOptions: {
                style: google.maps.ZoomControlStyle.LARGE,
                position: google.maps.ControlPosition.LEFT_CENTER
            }
		};

		$scope.marker = {
	      id: 0,
	      coords: {
	        latitude: $scope.event.mapa[0],
	        longitude: $scope.event.mapa[1]
	      },
	      options: { draggable: false },
	    };
	});


}]);


// Trivia Page
duarteApp.controller('triviaCtrl', ['$scope', 'Trivia',
function($scope, Trivia) {
	$scope.trivia = Trivia.query();
	$scope.add = function (i) {
       $scope.trivia.push(i);
    }
}]);


// Frases Page
duarteApp.controller('frasesCtrl', ['$scope', 'Frases',
function($scope, Frases) {
	$scope.frases = Frases.query();
	$scope.add = function (i) {
       $scope.frases.push(i);
    }
}]);


// Favorites Page
duarteApp.controller('favoritesCtrl', ['$scope',
function($scope){
	$scope.favorites = [];
	for ( var i = 0, len = localStorage.length; i < len; i++ ) {
		var item = localStorage.getItem(localStorage.key(i));
		if (item != 'notutorial') {
	  	$scope.favorites.push(JSON.parse(localStorage.getItem(localStorage.key(i))));
	  };
	}
}]);


// News page
duarteApp.controller('newsCtrl', ['$scope', '$routeParams', '$http',
function($scope, $routeParams, $http) {
	if($routeParams.nwId){
		$http.get('http://duarte-minerdgob.rhcloud.com/index.php/noticias/get_noticia?id='+$routeParams.nwId).success(function(data) {
			$scope.noticia = data.noticia;
		}).error(function(data) {
			alert("No se pudo cargar la noticia.");
		});
	}else{

		$http.get('http://duarte-minerdgob.rhcloud.com/index.php/noticias/get_noticias').success(function(data) {
			$scope.noticias = data.noticias;
		}).error(function(data) {
			alert("No se pudo cargar el listado de noticias.");
		});
	}
}]);


// Search Toggle
duarteApp.controller('searchCtrl', ['$scope',
function($scope){
	$scope.open = function () {
    	$scope.shouldBeOpen = true;
  	};
  	$scope.close = function () {
    	$scope.shouldBeOpen = false;
  	};
}]);


// Tutorial Modal
duarteApp.controller('tutCtrl', ['$scope',
function($scope){
	var tutSession = localStorage.getItem('tutorial');
	$scope.showTutorial = false;

	if (tutSession) {
    	$('#tutOverlay').css({'opacity': '0', 'pointer-events': 'none'});

    } else {
    	$scope.showTutorial = true;
    	$('#tutOverlay').css({'opacity': '1', 'pointer-events': 'auto'});

    }

    $scope.tutHide = function () {
    	$('#tutOverlay').css({'opacity': '0', 'pointer-events': 'none'});
    	localStorage.setItem('tutorial', 'notutorial');

    	$scope.showTutorial = false;
    }

    $scope.tutShow = function () {
    	$('#tutOverlay').css({'opacity': '1', 'pointer-events': 'auto'});

    	$scope.showTutorial = true;
    }

}]);

