'use strict';

/* Directives */

// Event Videos
duarteApp.directive('youtube', ['$sce', '$timeout', function($sce, $timeout) {
  return {
    restrict: 'EA',
    scope: { code:'=' },
    replace: true,
    template: '<iframe width="560" height="315" src="{{url}}" frameborder="0" allowfullscreen></iframe>',
    link: function (scope) {
      $timeout(function(){
        scope.$watch('code', function (newVal, oldVal) {
           if (newVal !== undefined) {
               scope.url = $sce.trustAsResourceUrl("http://www.youtube.com/embed/" + newVal + '?controls=1&showinfo=0&rel=0');
           }
        });
      }, 500);
    }
  };
}]);


// Event Audios
duarteApp.directive('mediaelem', function($timeout) {
  return {
    restrict: 'A',
    link: function(scope, element) {
       $timeout(function(){
         var eventAudio  = $(element).parent().attr('data-audio'),
             func = "playAudio('" + eventAudio + "');";

         $(element).attr('onclick', func);

       }, 500);
    }
  };
});


// Event Gallery
duarteApp.directive('swipebox', function() {
  return {
    restrict: 'A',
    link: function(scope, element) {
      if (scope.$last) setTimeout(function() {
       $('.swipebox').swipebox( {
            hideBarsOnMobile : false
          });
       }, 1);
    }
  };
});


// Slider
duarteApp.directive('flexslider', function($timeout) {
  return {
    restrict: 'A',
    link: function(scope, element) {
      $timeout(function(){
        $(element).flexslider({
          animation: 'slide',
          directionNav: false,
          slideshow: false
        });
      }, 100);
    }
  };
});


// Search Focus
duarteApp.directive('focusMe', function($timeout, $parse) {
  return {
    link: function(scope, element, attrs) {

      var model = $parse(attrs.focusMe),
          field = document.getElementById("searchfield"),
          nav   = document.getElementById("utilities"),
          devicePlatform = device.platform;

      scope.$watch(model, function(value) {

        if(value === true) {

          $timeout(function() {

            element[0].focus();
            nav.style.display = 'none';
            if (devicePlatform == 'Android') {
              SoftKeyboard.show();
            }

          }, 100);

        } else {

          $timeout(function() {

            element[0].blur();
            scope.query = scope.initial;
            field.value = '';
            nav.style.display = 'block';
            nav.style.bottom = 0;
            if (devicePlatform == 'Android') {
              SoftKeyboard.hide();
            }

          }, 400);

        }

      });
    }
  };
});

