/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

function onLoad() { document.addEventListener("deviceready", onDeviceReady, false); }

var Pushbots = null;

function onDeviceReady() {
    
    /*PUSHBOTS INITIALIZE*/
    Pushbots = PushbotsPlugin.initialize("569ea7d51779595e3d8b4567", {"android":{"sender_id":"96284172933"}});
    Pushbots.resetBadge();
    // Should be called once the notification is clicked
    // **important** Doesn't work with iOS while app is closed
    Pushbots.on("notification:clicked", function(data){
        Pushbots.resetBadge();    
        angular.element('#app-con').scope().getNotification(data);
    });

    // Should be called once app receive the notification
    Pushbots.on("notification:received", function(data){ 
        localStorage.setItem('notification_received', JSON.stringify({type : data.type, alias_id : data.alias_id}));
    });

    if((null !== localStorage.getItem('notification_received'))){
        check_notification();
    }

    document.addEventListener("pause", onPause, false);
    document.addEventListener("resume", onResume, false);
}

function onPause() {
    var loc     = window.location.href.split('#'),
        path    = '#' + loc[1];
    sessionStorage.setItem('appState', path);
}
function onResume() {
    var test = sessionStorage.getItem('appState');
    check_notification();
}  

function check_notification(){
    Pushbots.resetBadge();
    if((null !== localStorage.getItem('notification_received'))){
        Pushbots.resetBadge();
        angular.element('#app-con').scope().getNotification(JSON.parse(localStorage.getItem('notification_received')));
        localStorage.removeItem("notification_received");
    }
}

// Play audio
var my_media = null;
var mediaTimer = null;

function getPhoneGapPath() {

    var path = window.location.pathname;
    path = path.substr( path, path.length - 10 );
    return 'file://' + path;

};

function playAudio(src) {

    var devicePlatform = device.platform;

	if (devicePlatform == 'iOS') {

		var audioSrc = src;

	} else {

		var audioSrc = getPhoneGapPath() + src;

	}

   stopAudio();

    my_media = new Media(audioSrc, onSuccess, onError);

    // Play audio
    my_media.play();

    // Update my_media position every second
    if (mediaTimer == null) {
        mediaTimer = setInterval(function() {
            // get my_media position
            my_media.getCurrentPosition(
                // success callback
                function(position) {
                    if (position > -1) {
                        var total = my_media.getDuration();
                        setAudioPosition((position) + " - " + total);
                    }
                },
                // error callback
                function(e) {
                    //console.log("Error getting pos=" + e);
                    setAudioPosition("Error: " + e);
                }
            );
        }, 1000);
    }
}

// Pause audio
function pauseAudio() {
    if (my_media) {
        my_media.pause();
    }
}

// Stop audio
function stopAudio() {
    if (my_media) {
        my_media.stop();
        my_media = null;
    }
    clearInterval(mediaTimer);
    mediaTimer = null;
}

// onSuccess Callback
function onSuccess() {
    //console.log("playAudio():Audio Success");
}

// onError Callback
function onError(error) {
    alert('code: '    + error.code    + '\n' +
          'message: ' + error.message + '\n');
}

// Set audio position
function setAudioPosition(position) {
    document.getElementById('audio_position').innerHTML = position;
}

onLoad();
